(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-responsive-elements', ['exports', '@angular/core'], factory) :
    (global = global || self, factory(global['ngx-responsive-elements'] = {}, global.ng.core));
}(this, function (exports, core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ResponsiveElementDirective = /** @class */ (function () {
        function ResponsiveElementDirective(hostElement) {
            this.hostElement = hostElement;
            this.sizeMap = null;
            this.defaultCssClass = 'default';
            this.oldCssClass = null;
        }
        /**
         * @return {?}
         */
        ResponsiveElementDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.onResize(null);
        };
        /**
         * @param {?} elementSize
         * @return {?}
         */
        ResponsiveElementDirective.prototype.recalcClass = /**
         * @param {?} elementSize
         * @return {?}
         */
        function (elementSize) {
            if (!this.sizeMap) {
                return this.defaultCssClass;
            }
            /** @type {?} */
            var orderedKeys = Object.keys(this.sizeMap);
            /** @type {?} */
            var numberOfEntries = orderedKeys.length;
            for (var index = 0; index < numberOfEntries; index++) {
                /** @type {?} */
                var minSize = +orderedKeys[index];
                if (index <= numberOfEntries - 2) {
                    /** @type {?} */
                    var maxSize = +orderedKeys[index + 1];
                    if (elementSize >= minSize && elementSize < maxSize) {
                        return this.sizeMap[minSize];
                    }
                }
                else if (index === numberOfEntries - 1 &&
                    elementSize >= minSize) {
                    return this.sizeMap[minSize];
                }
            }
            return this.defaultCssClass;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        ResponsiveElementDirective.prototype.onResize = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (this.hostElement && this.hostElement.nativeElement) {
                /** @type {?} */
                var newCssClass = this.recalcClass(this.hostElement.nativeElement.clientWidth);
                if (this.oldCssClass !== newCssClass) {
                    if (this.oldCssClass !== null) {
                        this.hostElement.nativeElement.classList.remove(this.oldCssClass);
                    }
                    this.hostElement.nativeElement.classList.add(newCssClass);
                    this.oldCssClass = newCssClass;
                }
            }
        };
        ResponsiveElementDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngxReResponsiveElement]',
                    },] }
        ];
        /** @nocollapse */
        ResponsiveElementDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        ResponsiveElementDirective.propDecorators = {
            sizeMap: [{ type: core.Input }],
            defaultCssClass: [{ type: core.Input }],
            onResize: [{ type: core.HostListener, args: ['window:resize', ['$event'],] }]
        };
        return ResponsiveElementDirective;
    }());
    if (false) {
        /** @type {?} */
        ResponsiveElementDirective.prototype.sizeMap;
        /** @type {?} */
        ResponsiveElementDirective.prototype.defaultCssClass;
        /** @type {?} */
        ResponsiveElementDirective.prototype.oldCssClass;
        /**
         * @type {?}
         * @private
         */
        ResponsiveElementDirective.prototype.hostElement;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxResponsiveElementsModule = /** @class */ (function () {
        function NgxResponsiveElementsModule() {
        }
        NgxResponsiveElementsModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [ResponsiveElementDirective],
                        imports: [],
                        exports: [ResponsiveElementDirective],
                    },] }
        ];
        return NgxResponsiveElementsModule;
    }());

    exports.NgxResponsiveElementsModule = NgxResponsiveElementsModule;
    exports.ɵa = ResponsiveElementDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-responsive-elements.umd.js.map
