import { Directive, ElementRef, Input, HostListener, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ResponsiveElementDirective = /** @class */ (function () {
    function ResponsiveElementDirective(hostElement) {
        this.hostElement = hostElement;
        this.sizeMap = null;
        this.defaultCssClass = 'default';
        this.oldCssClass = null;
    }
    /**
     * @return {?}
     */
    ResponsiveElementDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.onResize(null);
    };
    /**
     * @param {?} elementSize
     * @return {?}
     */
    ResponsiveElementDirective.prototype.recalcClass = /**
     * @param {?} elementSize
     * @return {?}
     */
    function (elementSize) {
        if (!this.sizeMap) {
            return this.defaultCssClass;
        }
        /** @type {?} */
        var orderedKeys = Object.keys(this.sizeMap);
        /** @type {?} */
        var numberOfEntries = orderedKeys.length;
        for (var index = 0; index < numberOfEntries; index++) {
            /** @type {?} */
            var minSize = +orderedKeys[index];
            if (index <= numberOfEntries - 2) {
                /** @type {?} */
                var maxSize = +orderedKeys[index + 1];
                if (elementSize >= minSize && elementSize < maxSize) {
                    return this.sizeMap[minSize];
                }
            }
            else if (index === numberOfEntries - 1 &&
                elementSize >= minSize) {
                return this.sizeMap[minSize];
            }
        }
        return this.defaultCssClass;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    ResponsiveElementDirective.prototype.onResize = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (this.hostElement && this.hostElement.nativeElement) {
            /** @type {?} */
            var newCssClass = this.recalcClass(this.hostElement.nativeElement.clientWidth);
            if (this.oldCssClass !== newCssClass) {
                if (this.oldCssClass !== null) {
                    this.hostElement.nativeElement.classList.remove(this.oldCssClass);
                }
                this.hostElement.nativeElement.classList.add(newCssClass);
                this.oldCssClass = newCssClass;
            }
        }
    };
    ResponsiveElementDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxReResponsiveElement]',
                },] }
    ];
    /** @nocollapse */
    ResponsiveElementDirective.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    ResponsiveElementDirective.propDecorators = {
        sizeMap: [{ type: Input }],
        defaultCssClass: [{ type: Input }],
        onResize: [{ type: HostListener, args: ['window:resize', ['$event'],] }]
    };
    return ResponsiveElementDirective;
}());
if (false) {
    /** @type {?} */
    ResponsiveElementDirective.prototype.sizeMap;
    /** @type {?} */
    ResponsiveElementDirective.prototype.defaultCssClass;
    /** @type {?} */
    ResponsiveElementDirective.prototype.oldCssClass;
    /**
     * @type {?}
     * @private
     */
    ResponsiveElementDirective.prototype.hostElement;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxResponsiveElementsModule = /** @class */ (function () {
    function NgxResponsiveElementsModule() {
    }
    NgxResponsiveElementsModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [ResponsiveElementDirective],
                    imports: [],
                    exports: [ResponsiveElementDirective],
                },] }
    ];
    return NgxResponsiveElementsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxResponsiveElementsModule, ResponsiveElementDirective as ɵa };
//# sourceMappingURL=ngx-responsive-elements.js.map
